com.license4j

## Class LicenseValidator

- java.lang.Object
- - com.license4j.LicenseValidator

-     public class LicenseValidator
      extends java.lang.Object

  LicenseValidator class provides license and serial number validation methods, and it is included in runtime library.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `LicenseValidator()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static License` | `autoActivate(License license)` Activates given license on Online.License4J.
    `static License` | `autoActivate(License license, boolean modifyOnlyOnFirstActivation, java.lang.String fullname, java.lang.String registeredto, java.lang.String email, java.lang.String company, java.lang.String street, java.lang.String telnumber, java.lang.String faxnumber, java.lang.String city, java.lang.String zip, java.lang.String country)` Activates given license on Online.License4J with user information.
    `static License` | `autoActivate(License license, java.lang.String hostname)` Activates given license on defined Auto License Generation and Activation Server.
    `static License` | `autoActivate(License license, java.lang.String hostname, boolean modifyOnlyOnFirstActivation, java.lang.String fullname, java.lang.String registeredto, java.lang.String email, java.lang.String company, java.lang.String street, java.lang.String telnumber, java.lang.String faxnumber, java.lang.String city, java.lang.String zip, java.lang.String country)` Activates given license on defined Auto License Generation and Activation Server with user information.
    `static License` | `autoActivateWithCustomHardwareID(License license, java.lang.String customHardwareID)` Activates given license on Online.License4J with custom hardware ID.
    `static License` | `autoActivateWithCustomHardwareID(License license, java.lang.String customHardwareID, boolean modifyOnlyOnFirstActivation, java.lang.String fullname, java.lang.String registeredto, java.lang.String email, java.lang.String company, java.lang.String street, java.lang.String telnumber, java.lang.String faxnumber, java.lang.String city, java.lang.String zip, java.lang.String country)` Activates given license on Online.License4J with user information and custom hardware ID.
    `static License` | `autoActivateWithCustomHardwareID(License license, java.lang.String hostname, java.lang.String customHardwareID)` Activates given license on defined Auto License Generation and Activation Server with custom hardware ID.
    `static License` | `autoActivateWithCustomHardwareID(License license, java.lang.String hostname, java.lang.String customHardwareID, boolean modifyOnlyOnFirstActivation, java.lang.String fullname, java.lang.String registeredto, java.lang.String email, java.lang.String company, java.lang.String street, java.lang.String telnumber, java.lang.String faxnumber, java.lang.String city, java.lang.String zip, java.lang.String country)` Activates given license on defined Auto License Generation and Activation Server with user information and custom hardware ID.
    `static License` | `autoDeactivate(License license)` Deactivates an activated license on Online.License4J (removes activation on server, client side license removal must be performed by developer).
    `static License` | `autoDeactivate(License license, java.lang.String hostname)` Deactivates an activated license on given Auto License Generation and Activation Server (removes activation on server, client side license removal must be performed by developer).
    `static int` | `checkOnlineAvailability(java.lang.String publickey, License license, int timeout)` Check online availability of given license or activation on Online.License4J.
    `static int` | `checkOnlineAvailability(java.lang.String publickey, License license, java.lang.String server, int timeout)` Check online availability of given license or activation on server.
    `static License` | `checkoutFloatingLicenseTextCustomFeature(java.lang.String featureName, License license, java.lang.String serverAddress)` For only Floating License Text type license.
    `static License` | `easyValidate(java.lang.String licenseString, java.lang.String validationString)` Method gets license key or license text and validates.
    `static License` | `easyValidateOnStartup(java.lang.String validationString)` Method reads license file on disk and validates license.
    `static int` | `getFloatingLicenseServerVersion(java.net.InetAddress host, int port)` Method to get floating license server version.
    `static java.lang.String` | `getLibraryVersion()` License4J library version info.
    `static License` | `modifyLicense(License license, java.lang.String key)` Modifies given activated license on Online.License4J.
    `static License` | `modifyLicense(License license, java.lang.String hostname, java.lang.String key)` Modifies given activated license on defined Auto License Generation and Activation Server.
    `static License` | `releaseFloatingLicenseTextCustomFeature(java.lang.String featureName, License license, java.lang.String serverAddress)` For only Floating License Text type license.
    `static License` | `validate(java.lang.String publickey, java.lang.String productID, java.lang.String productEdition, java.lang.String currentProductVersion, java.util.Date currentDate, java.util.Date currentProductReleaseDate, java.net.InetAddress host, int port, FloatingLicenseValidHandler validHandler, FloatingLicenseInvalidHandler invalidHandler, FloatingLicenseServerConnectionErrorHandler serverConnectionErrorHandler)` Requests a floating license from given floating license server.
    `static License` | `validate(java.lang.String licenseString, java.lang.String publickey, java.lang.String productID, java.lang.String productEdition, java.lang.String currentProductVersion, java.util.Date currentDate, java.util.Date currentProductReleaseDate)` Validates given license text.
    `static License` | `validate(java.lang.String key, java.lang.String publickey, java.lang.String productID, java.lang.String productEdition, java.lang.String currentProductVersion, java.util.Date currentDate, java.util.Date currentProductReleaseDate, OnlineLicenseKeyCheckTimerHandler onlineLicenseKeyCheckTimerHandler)` Validate given online basic key floating over Internet on Online.License4J.
    `static License` | `validate(java.lang.String key, java.lang.String publickey, java.lang.String productID, java.lang.String productEdition, java.lang.String currentProductVersion, java.util.Date currentDate, java.util.Date currentProductReleaseDate, java.lang.String licenseServer, OnlineLicenseKeyCheckTimerHandler onlineLicenseKeyCheckTimerHandler)` Validate given online basic key floating over Internet on given Auto License Generation and Activation Server.
    `static License` | `validate(java.lang.String licenseString, java.lang.String publickey, java.lang.String internalString, java.lang.String nameforValidation, java.lang.String companyforValidation, int hardwareidValidation)` Validates given basic or cryptographically secure license key.
    `static License` | `validateFloatingLicenseText(java.lang.String publickey, java.lang.String productID, java.lang.String productEdition, java.lang.String productVersion, java.lang.String serverAddress, FloatingLicenseCheckTimerHandler floatingLicenseTimerTaskHandler)` Requests a floating license from given floating license server.
    `static License` | `validateFloatingLicenseText(java.lang.String publickey, java.lang.String productID, java.lang.String productEdition, java.lang.String productVersion, java.lang.String serverAddress, FloatingLicenseCheckTimerHandler floatingLicenseTimerTaskHandler, java.lang.String additionalInfo)` Requests a floating license from given floating license server.
    `static License` | `validateOnlineLicenseKey(java.lang.String key, java.lang.String publickey, java.lang.String productID, java.lang.String productEdition, java.lang.String productVersion, FloatingLicenseCheckTimerHandler floatingLicenseTimerTaskHandler)` Validate given online basic key floating over Internet on Online.License4J.
    `static License` | `validateOnlineLicenseKey(java.lang.String key, java.lang.String publickey, java.lang.String productID, java.lang.String productEdition, java.lang.String productVersion, FloatingLicenseCheckTimerHandler floatingLicenseTimerTaskHandler, java.lang.String additionalInfo)` Validate given online basic key floating over Internet on Online.License4J by sending an additional information to be displayed on related License Manager window.
    `static License` | `validateOnlineLicenseKey(java.lang.String key, java.lang.String publickey, java.lang.String productID, java.lang.String productEdition, java.lang.String productVersion, java.lang.String licenseServer, FloatingLicenseCheckTimerHandler floatingLicenseTimerTaskHandler)` Validate given online basic key floating over Internet on given Auto License Generation and Activation Server.
    `static License` | `validateOnlineLicenseKey(java.lang.String key, java.lang.String publickey, java.lang.String productID, java.lang.String productEdition, java.lang.String productVersion, java.lang.String licenseServer, FloatingLicenseCheckTimerHandler floatingLicenseTimerTaskHandler, java.lang.String additionalInfo)` Validate given online basic key floating over Internet on given Auto License Generation and Activation Server.
    `static License` | `validateWithCustomHardwareID(java.lang.String licenseString, java.lang.String publickey, java.lang.String internalString, java.lang.String nameforValidation, java.lang.String companyforValidation, java.lang.String customHardwareID)` Validates given basic or cryptographically secure license key with custom hardware ID.
    `static License` | `validateWithCustomHardwareID(java.lang.String licenseString, java.lang.String publickey, java.lang.String productID, java.lang.String productEdition, java.lang.String currentProductVersion, java.lang.String customHardwareID, java.util.Date currentDate, java.util.Date currentProductReleaseDate)` Validates given license text with custom hardware ID.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### LicenseValidator

          public LicenseValidator()

  - ### Method Detail

    - #### validate

          public static License validate(java.lang.String licenseString,
                         java.lang.String publickey,
                         java.lang.String productID,
                         java.lang.String productEdition,
                         java.lang.String currentProductVersion,
                         java.util.Date currentDate,
                         java.util.Date currentProductReleaseDate)

      Validates given license text. Validation status can be obtained with getValidationStatus() method of License object.
      Parameters:
        `licenseString` -
        `publickey` -
        `productID` -
        `productEdition` -
        `currentProductVersion` -
        `currentDate` -
        `currentProductReleaseDate` -
      Returns:
        License object

    - #### validateWithCustomHardwareID

          public static License validateWithCustomHardwareID(java.lang.String licenseString,
                                             java.lang.String publickey,
                                             java.lang.String productID,
                                             java.lang.String productEdition,
                                             java.lang.String currentProductVersion,
                                             java.lang.String customHardwareID,
                                             java.util.Date currentDate,
                                             java.util.Date currentProductReleaseDate)

      Validates given license text with custom hardware ID. Validation status can be obtained with getValidationStatus() method of License object.
      Parameters:
        `licenseString` -
        `publickey` -
        `productID` -
        `productEdition` -
        `currentProductVersion` -
        `customHardwareID` -
        `currentDate` -
        `currentProductReleaseDate` -
      Returns:
        License object

    - #### validate

          public static License validate(java.lang.String publickey,
                         java.lang.String productID,
                         java.lang.String productEdition,
                         java.lang.String currentProductVersion,
                         java.util.Date currentDate,
                         java.util.Date currentProductReleaseDate,
                         java.net.InetAddress host,
                         int port,
                         FloatingLicenseValidHandler validHandler,
                         FloatingLicenseInvalidHandler invalidHandler,
                         FloatingLicenseServerConnectionErrorHandler serverConnectionErrorHandler)

      Requests a floating license from given floating license server. Validation status can be obtained with getValidationStatus() method of License object.
      Parameters:
        `publickey` -
        `productID` -
        `productEdition` -
        `currentProductVersion` -
        `currentDate` -
        `currentProductReleaseDate` -
        `host` -
        `port` -
        `validHandler` -
        `invalidHandler` -
        `serverConnectionErrorHandler` -
      Returns:
        License object

    - #### validateFloatingLicenseText

          public static License validateFloatingLicenseText(java.lang.String publickey,
                                            java.lang.String productID,
                                            java.lang.String productEdition,
                                            java.lang.String productVersion,
                                            java.lang.String serverAddress,
                                            FloatingLicenseCheckTimerHandler floatingLicenseTimerTaskHandler)

      Requests a floating license from given floating license server. Validation status can be obtained with getValidationStatus() method of License object. This is the new basic method to validate floating license text. Floating license server address must be given in the format ServerAddress:PortNumber. Instead of defining single floating license server, more than one server address can be defined separated with semicolon.
      Parameters:
        `publickey` -
        `productID` -
        `productEdition` -
        `productVersion` -
        `serverAddress` -
        `floatingLicenseTimerTaskHandler` -
      Returns:
        License object

    - #### validateFloatingLicenseText

          public static License validateFloatingLicenseText(java.lang.String publickey,
                                            java.lang.String productID,
                                            java.lang.String productEdition,
                                            java.lang.String productVersion,
                                            java.lang.String serverAddress,
                                            FloatingLicenseCheckTimerHandler floatingLicenseTimerTaskHandler,
                                            java.lang.String additionalInfo)

      Requests a floating license from given floating license server. Validation status can be obtained with getValidationStatus() method of License object. This is the new basic method to validate floating license text. Floating license server address must be given in the format ServerAddress:PortNumber. Instead of defining single floating license server, more than one server address can be defined separated with semicolon. Method sends an additional information string to server and Floating License Server Administration GUI displays received string. String can be anything, max allowed length is 64. Strings longer than 64 characters in length will be truncated and first 64 characters will be sent to server.
      Parameters:
        `publickey` -
        `productID` -
        `productEdition` -
        `productVersion` -
        `serverAddress` -
        `floatingLicenseTimerTaskHandler` -
        `additionalInfo` -
      Returns:
        License object

    - #### checkoutFloatingLicenseTextCustomFeature

          public static License checkoutFloatingLicenseTextCustomFeature(java.lang.String featureName,
                                                         License license,
                                                         java.lang.String serverAddress)

      For only Floating License Text type license. If any custom signed feature is defined with concurrent use quantity, it is checked out with this method. LicenseText object obtained with validateFloatingLicenseText method by default will not include custom signed features with concurrent quantity defined. To get those custom signed features, they must be checked out first. When checked out, license.getLicenseText().getCustomSignedFeature("featureName") method will return feature value defined if it is successfully checked out; will return empty string if all are checked out and there is no available feature; will return null if there is no such a custom signed feature.
      Parameters:
        `featureName` -
        `license` -
        `serverAddress` -
      Returns:
        license object

    - #### releaseFloatingLicenseTextCustomFeature

          public static License releaseFloatingLicenseTextCustomFeature(java.lang.String featureName,
                                                        License license,
                                                        java.lang.String serverAddress)

      For only Floating License Text type license. If any custom signed feature is defined with concurrent use quantity, and it is checked out, it will be released with this method.
      Parameters:
        `featureName` -
        `license` -
        `serverAddress` -
      Returns:
        license object

    - #### validate

          public static License validate(java.lang.String licenseString,
                         java.lang.String publickey,
                         java.lang.String internalString,
                         java.lang.String nameforValidation,
                         java.lang.String companyforValidation,
                         int hardwareidValidation)

      Validates given basic or cryptographically secure license key. Validation status can be obtained with getValidationStatus() method of License object.
      Parameters:
        `licenseString` -
        `publickey` -
        `internalString` -
        `nameforValidation` -
        `companyforValidation` -
        `hardwareidValidation` -
      Returns:
        License object

    - #### validateWithCustomHardwareID

          public static License validateWithCustomHardwareID(java.lang.String licenseString,
                                             java.lang.String publickey,
                                             java.lang.String internalString,
                                             java.lang.String nameforValidation,
                                             java.lang.String companyforValidation,
                                             java.lang.String customHardwareID)

      Validates given basic or cryptographically secure license key with custom hardware ID. Validation status can be obtained with getValidationStatus() method of License object.
      Parameters:
        `licenseString` -
        `publickey` -
        `internalString` -
        `nameforValidation` -
        `companyforValidation` -
        `customHardwareID` -
      Returns:
        License object

    - #### validate

          public static License validate(java.lang.String key,
                         java.lang.String publickey,
                         java.lang.String productID,
                         java.lang.String productEdition,
                         java.lang.String currentProductVersion,
                         java.util.Date currentDate,
                         java.util.Date currentProductReleaseDate,
                         OnlineLicenseKeyCheckTimerHandler onlineLicenseKeyCheckTimerHandler)

      Validate given online basic key floating over Internet on Online.License4J. A license text is obtained and validation performed for given arguments. Validation status can be obtained with getValidationStatus() method of License object.
      Parameters:
        `key` -
        `publickey` -
        `productID` -
        `productEdition` -
        `currentProductVersion` -
        `currentDate` -
        `currentProductReleaseDate` -
        `onlineLicenseKeyCheckTimerHandler` -
      Returns:
        License object including a license text

    - #### validateOnlineLicenseKey

          public static License validateOnlineLicenseKey(java.lang.String key,
                                         java.lang.String publickey,
                                         java.lang.String productID,
                                         java.lang.String productEdition,
                                         java.lang.String productVersion,
                                         FloatingLicenseCheckTimerHandler floatingLicenseTimerTaskHandler)

      Validate given online basic key floating over Internet on Online.License4J. A license text is obtained and validation performed for given arguments. Validation status can be obtained with getValidationStatus() method of License object. This the new basic method to validate online license key.
      Parameters:
        `key` -
        `publickey` -
        `productID` -
        `productEdition` -
        `productVersion` -
        `floatingLicenseTimerTaskHandler` -
      Returns:
        License object including a license text

    - #### validateOnlineLicenseKey

          public static License validateOnlineLicenseKey(java.lang.String key,
                                         java.lang.String publickey,
                                         java.lang.String productID,
                                         java.lang.String productEdition,
                                         java.lang.String productVersion,
                                         FloatingLicenseCheckTimerHandler floatingLicenseTimerTaskHandler,
                                         java.lang.String additionalInfo)

      Validate given online basic key floating over Internet on Online.License4J by sending an additional information to be displayed on related License Manager window. A license text is obtained and validation performed for given arguments. Validation status can be obtained with getValidationStatus() method of License object. This the new basic method to validate online license key. Method sends an additional information string to server and License Manager displays received string. String can be anything, max allowed length is 64. Strings longer than 64 characters in length will be truncated and first 64 characters will be sent to server.
      Parameters:
        `key` -
        `publickey` -
        `productID` -
        `productEdition` -
        `productVersion` -
        `floatingLicenseTimerTaskHandler` -
        `additionalInfo` -
      Returns:
        License object including a license text

    - #### validate

          public static License validate(java.lang.String key,
                         java.lang.String publickey,
                         java.lang.String productID,
                         java.lang.String productEdition,
                         java.lang.String currentProductVersion,
                         java.util.Date currentDate,
                         java.util.Date currentProductReleaseDate,
                         java.lang.String licenseServer,
                         OnlineLicenseKeyCheckTimerHandler onlineLicenseKeyCheckTimerHandler)

      Validate given online basic key floating over Internet on given Auto License Generation and Activation Server. A license text is obtained and validation performed for given arguments. Validation status can be obtained with getValidationStatus() method of License object.
      Parameters:
        `key` -
        `publickey` -
        `productID` -
        `productEdition` -
        `currentProductVersion` -
        `currentDate` -
        `currentProductReleaseDate` -
        `licenseServer` -
        `onlineLicenseKeyCheckTimerHandler` -
      Returns:
        License object including a license text

    - #### validateOnlineLicenseKey

          public static License validateOnlineLicenseKey(java.lang.String key,
                                         java.lang.String publickey,
                                         java.lang.String productID,
                                         java.lang.String productEdition,
                                         java.lang.String productVersion,
                                         java.lang.String licenseServer,
                                         FloatingLicenseCheckTimerHandler floatingLicenseTimerTaskHandler)

      Validate given online basic key floating over Internet on given Auto License Generation and Activation Server. A license text is obtained and validation performed for given arguments. Validation status can be obtained with getValidationStatus() method of License object. This the new basic method to validate online license key. License server address must be given in the format ServerAddress:PortNumber. Instead of defining single license server, more than one server address can be defined separated with semicolon.
      Parameters:
        `key` -
        `publickey` -
        `productID` -
        `productEdition` -
        `productVersion` -
        `licenseServer` -
        `floatingLicenseTimerTaskHandler` -
      Returns:
        License object including a license text

    - #### validateOnlineLicenseKey

          public static License validateOnlineLicenseKey(java.lang.String key,
                                         java.lang.String publickey,
                                         java.lang.String productID,
                                         java.lang.String productEdition,
                                         java.lang.String productVersion,
                                         java.lang.String licenseServer,
                                         FloatingLicenseCheckTimerHandler floatingLicenseTimerTaskHandler,
                                         java.lang.String additionalInfo)

      Validate given online basic key floating over Internet on given Auto License Generation and Activation Server. A license text is obtained and validation performed for given arguments. Validation status can be obtained with getValidationStatus() method of License object. This the new basic method to validate online license key. License server address must be given in the format ServerAddress:PortNumber. Instead of defining single license server, more than one server address can be defined separated with semicolon. Method sends an additional information string to server and License Manager displays received string. String can be anything, max allowed length is 64. Strings longer than 64 characters in length will be truncated and first 64 characters will be sent to server.
      Parameters:
        `key` -
        `publickey` -
        `productID` -
        `productEdition` -
        `productVersion` -
        `licenseServer` -
        `floatingLicenseTimerTaskHandler` -
        `additionalInfo` -
      Returns:
        License object including a license text

    - #### autoActivate

          public static License autoActivate(License license)

      Activates given license on Online.License4J. Activation status can be obtained with getActivationStatus() method of License object.
      Parameters:
        `license` -
      Returns:
        License object

    - #### autoActivateWithCustomHardwareID

          public static License autoActivateWithCustomHardwareID(License license,
                                                 java.lang.String customHardwareID)

      Activates given license on Online.License4J with custom hardware ID. Activation status can be obtained with getActivationStatus() method of License object.
      Parameters:
        `license` -
        `customHardwareID` -
      Returns:
        License object

    - #### autoActivate

          public static License autoActivate(License license,
                             java.lang.String hostname)

      Activates given license on defined Auto License Generation and Activation Server. Activation status can be obtained with getActivationStatus() method of License object.
      Parameters:
        `license` -
        `hostname` -
      Returns:
        License object

    - #### autoActivateWithCustomHardwareID

          public static License autoActivateWithCustomHardwareID(License license,
                                                 java.lang.String hostname,
                                                 java.lang.String customHardwareID)

      Activates given license on defined Auto License Generation and Activation Server with custom hardware ID. Activation status can be obtained with getActivationStatus() method of License object.
      Parameters:
        `license` -
        `hostname` -
        `customHardwareID` -
      Returns:
        License object

    - #### autoActivate

          public static License autoActivate(License license,
                             boolean modifyOnlyOnFirstActivation,
                             java.lang.String fullname,
                             java.lang.String registeredto,
                             java.lang.String email,
                             java.lang.String company,
                             java.lang.String street,
                             java.lang.String telnumber,
                             java.lang.String faxnumber,
                             java.lang.String city,
                             java.lang.String zip,
                             java.lang.String country)

      Activates given license on Online.License4J with user information. Activation status can be obtained with getActivationStatus() method of License object.
      Parameters:
        `license` -
        `modifyOnlyOnFirstActivation` -
        `fullname` -
        `registeredto` -
        `email` -
        `company` -
        `street` -
        `telnumber` -
        `faxnumber` -
        `city` -
        `zip` -
        `country` -
      Returns:
        License object

    - #### autoActivateWithCustomHardwareID

          public static License autoActivateWithCustomHardwareID(License license,
                                                 java.lang.String customHardwareID,
                                                 boolean modifyOnlyOnFirstActivation,
                                                 java.lang.String fullname,
                                                 java.lang.String registeredto,
                                                 java.lang.String email,
                                                 java.lang.String company,
                                                 java.lang.String street,
                                                 java.lang.String telnumber,
                                                 java.lang.String faxnumber,
                                                 java.lang.String city,
                                                 java.lang.String zip,
                                                 java.lang.String country)

      Activates given license on Online.License4J with user information and custom hardware ID. Activation status can be obtained with getActivationStatus() method of License object.
      Parameters:
        `license` -
        `customHardwareID` -
        `modifyOnlyOnFirstActivation` -
        `fullname` -
        `registeredto` -
        `email` -
        `company` -
        `street` -
        `telnumber` -
        `faxnumber` -
        `city` -
        `zip` -
        `country` -
      Returns:
        License object

    - #### autoActivate

          public static License autoActivate(License license,
                             java.lang.String hostname,
                             boolean modifyOnlyOnFirstActivation,
                             java.lang.String fullname,
                             java.lang.String registeredto,
                             java.lang.String email,
                             java.lang.String company,
                             java.lang.String street,
                             java.lang.String telnumber,
                             java.lang.String faxnumber,
                             java.lang.String city,
                             java.lang.String zip,
                             java.lang.String country)

      Activates given license on defined Auto License Generation and Activation Server with user information. Activation status can be obtained with getActivationStatus() method of License object.
      Parameters:
        `license` - object
        `hostname` - activation server hostname
        `fullname` -
        `registeredto` -
        `email` -
        `company` -
        `street` -
        `telnumber` -
        `faxnumber` -
        `city` -
        `zip` -
        `country` -
        `modifyOnlyOnFirstActivation` -
      Returns:
        License object

    - #### autoActivateWithCustomHardwareID

          public static License autoActivateWithCustomHardwareID(License license,
                                                 java.lang.String hostname,
                                                 java.lang.String customHardwareID,
                                                 boolean modifyOnlyOnFirstActivation,
                                                 java.lang.String fullname,
                                                 java.lang.String registeredto,
                                                 java.lang.String email,
                                                 java.lang.String company,
                                                 java.lang.String street,
                                                 java.lang.String telnumber,
                                                 java.lang.String faxnumber,
                                                 java.lang.String city,
                                                 java.lang.String zip,
                                                 java.lang.String country)

      Activates given license on defined Auto License Generation and Activation Server with user information and custom hardware ID. Activation status can be obtained with getActivationStatus() method of License object.
      Parameters:
        `license` - object
        `hostname` - activation server hostname
        `customHardwareID` -
        `fullname` -
        `registeredto` -
        `email` -
        `company` -
        `street` -
        `telnumber` -
        `faxnumber` -
        `city` -
        `zip` -
        `country` -
        `modifyOnlyOnFirstActivation` -
      Returns:
        License object

    - #### autoDeactivate

          public static License autoDeactivate(License license)

      Deactivates an activated license on Online.License4J (removes activation on server, client side license removal must be performed by developer). Deactivation status can be obtained with getActivationStatus() method of License object.
      Parameters:
        `license` -
      Returns:
        license object with ACTIVATIONSTATUS set.

    - #### autoDeactivate

          public static License autoDeactivate(License license,
                               java.lang.String hostname)

      Deactivates an activated license on given Auto License Generation and Activation Server (removes activation on server, client side license removal must be performed by developer). Deactivation status can be obtained with getActivationStatus() method of License object.
      Parameters:
        `license` -
        `hostname` -
      Returns:
        license object with ACTIVATIONSTATUS set.

    - #### modifyLicense

          public static License modifyLicense(License license,
                              java.lang.String key)

      Modifies given activated license on Online.License4J. Modification status can be obtained with getModificationStatus() method of License object.
      Parameters:
        `license` -
        `key` -
      Returns:
        License object

    - #### modifyLicense

          public static License modifyLicense(License license,
                              java.lang.String hostname,
                              java.lang.String key)

      Modifies given activated license on defined Auto License Generation and Activation Server. Modification status can be obtained with getModificationStatus() method of License object.
      Parameters:
        `license` -
        `hostname` -
        `key` -
      Returns:
        License object

    - #### getFloatingLicenseServerVersion

          public static int getFloatingLicenseServerVersion(java.net.InetAddress host,
                                            int port)

      Method to get floating license server version. It sends a request to floating license server to get version number.
      Parameters:
        `host` -
        `port` -
      Returns:
        floating license server version

    - #### getLibraryVersion

          public static java.lang.String getLibraryVersion()

      License4J library version info.
      Returns:
        License4J library version string

    - #### checkOnlineAvailability

          public static int checkOnlineAvailability(java.lang.String publickey,
                                    License license,
                                    int timeout)

      Check online availability of given license or activation on Online.License4J. Can be used to check blacklisted and/or deleted licenses/activations.
      Parameters:
        `publickey` -
        `license` -
        `timeout` -
      Returns:
        -1 if cannot connect to server, 0 if license/activation is not found (deleted) on server, 1 if license is found on server. -2 if license ValidationStatus is not valid.

    - #### checkOnlineAvailability

          public static int checkOnlineAvailability(java.lang.String publickey,
                                    License license,
                                    java.lang.String server,
                                    int timeout)

      Check online availability of given license or activation on server. Can be used to check blacklisted and/or deleted licenses/activations.
      Parameters:
        `publickey` -
        `license` -
        `server` -
        `timeout` -
      Returns:
        -1 if cannot connect to server, 0 if license/activation is not found (deleted) on server, 1 if license is found on server. -2 if license ValidationStatus is not valid.

    - #### easyValidateOnStartup

          public static License easyValidateOnStartup(java.lang.String validationString)

      Method reads license file on disk and validates license. If license requires activation it activates license. License file is saved in a folder named as product name starting with a dot in user's home folder. The license file name is 'license'. validationString is an encrypted text which includes all parameters for license validation. It can only be generated with License Manager GUI; the required menu item is available on template management window. It is created for templates so all licenses generated with the template can be validated. This method must be used on software product startup usually in main method or after displaying main frame etc.
      Parameters:
        `validationString` -
      Returns:
        License object

    - #### easyValidate

          public static License easyValidate(java.lang.String licenseString,
                             java.lang.String validationString)

      Method gets license key or license text and validates. If activation is required it also activates license. License file is saved in a folder named as product name starting with a dot in user's home folder. The license file name is 'license'. validationString is an encrypted text which includes all parameters for license validation. It can only be generated with License Manager GUI; the required menu item is available on template management window. It is created for templates so all licenses generated with the template can be validated. This method must be used to validate given license. It should be used in a licensing window or dialog to validate given license.
      Parameters:
        `licenseString` -
        `validationString` -
      Returns:
        License object